diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/arch-ep93xx/time.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/arch-ep93xx/time.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/arch-ep93xx/time.h	2005-01-18 15:35:57.000000000 -0700
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/arch-ep93xx/time.h	2005-08-12 15:41:58.000000000 -0600
@@ -5,6 +5,9 @@
  *
  * Copyright (C) 2002-2003 Cirrus Logic, Inc.
  *
+ * Copyright (C) 2004-2005 Michael Neuhauser, Firmix Software GmbH (mike@firmix.at)
+ * 	more Adeos/RTAI friendly
+ *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
@@ -22,32 +25,48 @@
 #include <asm/system.h>
 #include <asm/leds.h>
 #include <asm/arch/hardware.h>
+#include <asm/arch/ep93xx_tsc.h>
 
 /* First timer channel used for timer interrupt */
 
 /*
  * IRQ handler for the timer
+ *
+ * interrupts are disabled because timer_irq has SA_INTERRUPT set (see
+ * arch/arm/time.c) (of course not if Adeos is active)
  */
-static void ep93xx_timer_interrupt(int irq, void *dev_id, struct pt_regs *regs)
+static void
+ep93xx_timer_interrupt(int irq, void *dev_id, struct pt_regs *regs)
 {
-
-    // ...clear the interrupt
-    outl( 1, TIMER1CLEAR );
-
+    /* Note, that the irq needs to be acked on a timer-hardware specific
+     * level (i.e. write 1 to TIMER1CLEAR). But because
+     * irq_desc[IRQ_TIMER1].mask_ack does that (non-standard modification), it
+     * does not have to be done here. This makes this function safe to use when
+     * RTAI/Adeos is active and handles the interrupts */
+    do_leds();
+    {
+	/* full jiffies according to TSC (i.e. absolute clock) */
+	unsigned long long realtime_jiffies =
+	    (ep93xx_read_and_update_tsc() * HZ) / FREQ_EP93XX_TSC;
+	/* call do_timer() as often as it is necessary to keep jiffies in sync
+	 * with TSC, take care that jiffies are never ahead the TSC
+	 * (gettimeoffset is unsigned) */
+	while (ep93xx_jiffies_done < realtime_jiffies) {
     do_timer(regs);
+	    ++ep93xx_jiffies_done;
+	}
+    }
     do_profile(regs);
 }
 
 /*
- * Set up timer interrupt, and return the current time in seconds.
+ * Set up timer interrupt
  */
-extern __inline__ void setup_timer(void)
+extern inline void
+setup_timer(void)
 {
+    ep93xx_setup_timer();
     timer_irq.handler = ep93xx_timer_interrupt;
-
-    /* 
-     * Make irqs happen for the system timer
-     */
     setup_arm_irq(IRQ_TIMER1, &timer_irq);
 
     /*
@@ -69,3 +88,14 @@ extern __inline__ void setup_timer(void)
     outl( 0xC8, TIMER1CONTROL );
 }
 
+
+#ifdef CONFIG_ADEOS_CORE
+static inline void
+__adeos_set_timer(unsigned long hz)
+{
+    unsigned long delay = (CLOCK_TICK_RATE + hz/2) / hz - 1;
+    outl(0, TIMER1CONTROL);         	/* stop timer */
+    outl(delay, TIMER1LOAD);		/* set load value */
+    outl(0xc8, TIMER1CONTROL);		/* set 508 kHz clock, periodic mode & enable timer */
+}
+#endif /* CONFIG_ADEOS_CORE */
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/arch-ep93xx/timex.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/arch-ep93xx/timex.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/arch-ep93xx/timex.h	2004-07-22 13:50:54.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/arch-ep93xx/timex.h	2005-08-12 15:41:58.000000000 -0600
@@ -5,6 +5,9 @@
  *
  *  Copyright (C) 1999 ARM Limited
  *
+ * Copyright (C) 2004-2005 Michael Neuhauser, Firmix Software GmbH (mike@firmix.at)
+ * 	corrected CLOCK_TICK_RATE, added defines for exact frequency
+ *  
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
@@ -23,4 +26,21 @@
 /*
  * ??
  */
-#define CLOCK_TICK_RATE		(50000000 / 16)
+#ifndef _ASM_ARM_ARCH_EP93XX_H
+#define _ASM_ARM_ARCH_EP93XX_H
+
+/*
+ * The original value of 508000 is completly wrong. Table 4-2 on page 74 of the
+ * EP9301 User's Manual gives the frequency as 508.4689 kHz and specifies that
+ * all timer clocks are derived from the external 14.7456 MHz oscillator by
+ * division. Hence, the correct frequency is most likely
+ * 14745.6 / 29 = 508.468965... kHz (rounded integer: 508469 Hz).
+ * -- Michael Neuhauser <mike@firimix.at>
+ */
+#define CLOCK_TICK_RATE		(508469)
+
+/* exact value (non-standard macros) */
+#define CLOCK_TICK_RATE_NUM	(14745600)
+#define CLOCK_TICK_RATE_DEN	(29)
+
+#endif /* _ASM_ARM_ARCH_EP93XX_H */
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/atomic.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/atomic.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/atomic.h	2004-07-22 13:50:53.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/atomic.h	2005-08-12 15:41:58.000000000 -0600
@@ -26,9 +26,19 @@ typedef struct { volatile int counter; }
 
 #define ATOMIC_INIT(i)	{ (i) }
 
-#ifdef __KERNEL__
+/* RTAI needs some atomic functions in user-space (for liblxrt) */
+#if defined(__KERNEL__) || defined(CONFIG_ADEOS_CORE)
+
 #include <asm/proc/system.h>
 
+#ifdef CONFIG_ADEOS_CORE
+#define _atomic_save_flags_cli(x)	adeos_hw_local_irq_save(flags)
+#define _atomic_restore_flags(x)	adeos_hw_local_irq_restore(flags)
+#else
+#define _atomic_save_flags_cli(x)	local_irq_save(x)
+#define _atomic_restore_flags(x)	local_irq_restore(x)
+#endif
+
 #define atomic_read(v)	((v)->counter)
 #define atomic_set(v,i)	(((v)->counter) = (i))
 
@@ -36,36 +46,36 @@ static inline void atomic_add(int i, vol
 {
 	unsigned long flags;
 
-	local_irq_save(flags);
+	_atomic_save_flags_cli(flags);
 	v->counter += i;
-	local_irq_restore(flags);
+	_atomic_restore_flags(flags);
 }
 
 static inline void atomic_sub(int i, volatile atomic_t *v)
 {
 	unsigned long flags;
 
-	local_irq_save(flags);
+	_atomic_save_flags_cli(flags);
 	v->counter -= i;
-	local_irq_restore(flags);
+	_atomic_restore_flags(flags);
 }
 
 static inline void atomic_inc(volatile atomic_t *v)
 {
 	unsigned long flags;
 
-	local_irq_save(flags);
+	_atomic_save_flags_cli(flags);
 	v->counter += 1;
-	local_irq_restore(flags);
+	_atomic_restore_flags(flags);
 }
 
 static inline void atomic_dec(volatile atomic_t *v)
 {
 	unsigned long flags;
 
-	local_irq_save(flags);
+	_atomic_save_flags_cli(flags);
 	v->counter -= 1;
-	local_irq_restore(flags);
+	_atomic_restore_flags(flags);
 }
 
 static inline int atomic_dec_and_test(volatile atomic_t *v)
@@ -73,10 +83,10 @@ static inline int atomic_dec_and_test(vo
 	unsigned long flags;
 	int val;
 
-	local_irq_save(flags);
+	_atomic_save_flags_cli(flags);
 	val = v->counter;
 	v->counter = val -= 1;
-	local_irq_restore(flags);
+	_atomic_restore_flags(flags);
 
 	return val == 0;
 }
@@ -86,10 +96,10 @@ static inline int atomic_add_negative(in
 	unsigned long flags;
 	int val;
 
-	local_irq_save(flags);
+	_atomic_save_flags_cli(flags);
 	val = v->counter;
 	v->counter = val += i;
-	local_irq_restore(flags);
+	_atomic_restore_flags(flags);
 
 	return val < 0;
 }
@@ -98,9 +108,9 @@ static inline void atomic_clear_mask(uns
 {
 	unsigned long flags;
 
-	local_irq_save(flags);
+	_atomic_save_flags_cli(flags);
 	*addr &= ~mask;
-	local_irq_restore(flags);
+	_atomic_restore_flags(flags);
 }
 
 /* Atomic operations are already serializing on ARM */
@@ -109,5 +119,5 @@ static inline void atomic_clear_mask(uns
 #define smp_mb__before_atomic_inc()	barrier()
 #define smp_mb__after_atomic_inc()	barrier()
 
-#endif
+#endif /* defined(__KERNEL__) || defined(CONFIG_ADEOS_CORE) */
 #endif
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/bitops.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/bitops.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/bitops.h	2004-07-22 13:50:53.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/bitops.h	2005-08-12 15:41:58.000000000 -0600
@@ -86,7 +86,7 @@ extern int find_next_zero_bit(void * add
 /*
  * This routine doesn't need to be atomic.
  */
-static inline int test_bit(int nr, const void * addr)
+static inline int test_bit(int nr, const volatile void * addr)
 {
     return (((unsigned char *) addr)[nr >> 3] >> (nr & 7)) & 1;
 }	
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/hw_irq.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/hw_irq.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/hw_irq.h	1969-12-31 17:00:00.000000000 -0700
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/hw_irq.h	2005-08-12 15:41:58.000000000 -0600
@@ -0,0 +1,7 @@
+/*
+ * hw_irq.h
+ *
+ * just a dummy for include/linux/irq.c
+ */
+
+#include <asm/irq.h>
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/irq.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/irq.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/irq.h	2004-07-22 13:50:53.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/irq.h	2005-08-12 15:41:58.000000000 -0600
@@ -1,6 +1,7 @@
 #ifndef __ASM_ARM_IRQ_H
 #define __ASM_ARM_IRQ_H
 
+#include <linux/linkage.h>
 #include <asm/arch/irqs.h>
 
 #ifndef irq_cannonicalize
@@ -23,6 +24,8 @@
 
 extern void disable_irq(unsigned int);
 extern void enable_irq(unsigned int);
+extern asmlinkage void asm_do_IRQ(int irq, struct pt_regs *regs);
+
 
 #endif
 
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/mach/irq.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/mach/irq.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/mach/irq.h	2004-07-22 13:50:53.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/mach/irq.h	2005-08-12 15:41:58.000000000 -0600
@@ -10,6 +10,8 @@
 #ifndef __ASM_ARM_MACH_IRQ_H
 #define __ASM_ARM_MACH_IRQ_H
 
+#include <linux/config.h>
+
 struct irqdesc {
 	unsigned int	 triggered: 1;		/* IRQ has occurred	      */
 	unsigned int	 running  : 1;		/* IRQ is running             */
@@ -28,6 +30,7 @@ struct irqdesc {
 	void (*unmask)(unsigned int irq);	/* Unmask IRQ		      */
 	struct irqaction *action;
 
+#ifndef CONFIG_ADEOS_CORE			/* no IRQ lock detection to increase performance */
 	/*
 	 * IRQ lock detection
 	 */
@@ -36,6 +39,7 @@ struct irqdesc {
 	unsigned int	 lck_jif;
 	int		 lck_warned;
 	struct timer_list	lck_timer;
+#endif /* !CONFIG_ADEOS_CORE */
 };
 
 extern struct irqdesc irq_desc[];
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/pgalloc.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/pgalloc.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/pgalloc.h	2004-07-22 13:50:53.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/pgalloc.h	2005-08-12 15:41:58.000000000 -0600
@@ -138,4 +138,33 @@ static inline pgd_t *pgd_alloc(struct mm
 
 extern int do_check_pgt_cache(int, int);
 
+#ifdef CONFIG_ADEOS_CORE
+extern inline void set_pgdir(unsigned long address, pgd_t entry)
+{
+	struct task_struct * p;
+	pgd_t *pgd;
+#ifdef CONFIG_SMP
+	int i;
+#endif
+
+	read_lock(&tasklist_lock);
+	for_each_task(p) {
+		if (!p->mm)
+			continue;
+		*pgd_offset(p->mm,address) = entry;
+	}
+	read_unlock(&tasklist_lock);
+#ifndef CONFIG_SMP
+	for (pgd = (pgd_t *)pgd_quicklist; pgd; pgd = (pgd_t *)__pgd_next(pgd))
+		pgd[pgd_index(address)] = entry;
+#else
+	/* To pgd_alloc/pgd_free, one holds master kernel lock and so does our callee, so we can
+	   modify pgd caches of other CPUs as well. -jj */
+	for (i = 0; i < NR_CPUS; i++)
+		for (pgd = (pgd_t *)cpu_data[i].pgd_quick; pgd; pgd = (pgd_t *)__pgd_next(pgd))
+			pgd[pgd_index(address)] = entry;
+#endif
+}
+#endif /* CONFIG_ADEOS_CORE */
+
 #endif
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/proc-armv/processor.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/proc-armv/processor.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/proc-armv/processor.h	2004-08-03 19:17:09.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/proc-armv/processor.h	2005-08-12 15:41:58.000000000 -0600
@@ -18,6 +18,7 @@
 #ifndef __ASM_PROC_PROCESSOR_H
 #define __ASM_PROC_PROCESSOR_H
 
+#include <linux/config.h>
 #include <asm/proc/domain.h>
 
 #define KERNEL_STACK_SIZE	PAGE_SIZE
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/proc-armv/system.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/proc-armv/system.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/proc-armv/system.h	2004-07-22 13:50:54.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/proc-armv/system.h	2005-08-12 15:41:58.000000000 -0600
@@ -42,6 +42,114 @@ extern unsigned long cr_alignment;	/* de
 #define vectors_base()	(0)
 #endif
 
+/* ========================================================================= */
+#if defined(CONFIG_ADEOS_CORE)
+
+/* --------------------------------- Adeos --------------------------------- */
+
+extern inline void __adeos_stall_root(void);
+
+extern inline void __adeos_unstall_root(void);
+
+extern inline unsigned long __adeos_test_root(void);
+
+extern inline unsigned long __adeos_test_and_stall_root(void);
+
+void __adeos_restore_root(unsigned long flags);
+
+#define __stf()                 __adeos_unstall_root()
+#define __clf()                 __adeos_stall_root()
+
+#define local_save_flags(x)	((x) = __adeos_test_root())
+#define local_irq_save(x)	((x) = __adeos_test_and_stall_root())
+#define local_irq_restore(x)	__adeos_restore_root(x)
+#define local_irq_set(x)	do { ((x) = __adeos_test_root()); __adeos_unstall_root(); } while (0)
+#define local_irq_disable()	__adeos_stall_root()
+#define local_irq_enable()	__adeos_unstall_root()
+
+#define irqs_disabled()         __adeos_test_root()
+
+#define adeos_hw_cli() \
+	({							\
+		unsigned long temp;				\
+	__asm__ __volatile__(					\
+	"mrs	%0, cpsr		@ cli\n"		\
+"	orr	%0, %0, #128\n"					\
+"	msr	cpsr_c, %0"					\
+	: "=r" (temp)						\
+	:							\
+	: "memory");						\
+	})
+
+#define adeos_hw_sti()	\
+	({							\
+		unsigned long temp;				\
+	__asm__ __volatile__(					\
+	"mrs	%0, cpsr		@ sti\n"		\
+"	bic	%0, %0, #128\n"					\
+"	msr	cpsr_c, %0"					\
+	: "=r" (temp)						\
+	:							\
+	: "memory");						\
+	})
+
+
+#define adeos_hw_stf()	\
+	({							\
+		unsigned long temp;				\
+	__asm__ __volatile__(					\
+	"mrs	%0, cpsr		@ stf\n"		\
+"	bic	%0, %0, #64\n"					\
+"	msr	cpsr_c, %0"					\
+	: "=r" (temp)						\
+	:							\
+	: "memory");						\
+	})
+
+#define adeos_hw_clf()	\
+	({							\
+		unsigned long temp;				\
+	__asm__ __volatile__(					\
+	"mrs	%0, cpsr		@ clf\n"		\
+"	orr	%0, %0, #64\n"					\
+"	msr	cpsr_c, %0"					\
+	: "=r" (temp)						\
+	:							\
+	: "memory");						\
+	})
+
+
+#define adeos_hw_local_irq_save(x) \
+	({							\
+		unsigned long temp;				\
+	__asm__ __volatile__(					\
+	"mrs	%0, cpsr		@ save_flags_cli\n"	\
+"	orr	%1, %0, #128\n"					\
+"	msr	cpsr_c, %1"					\
+	: "=r" (x), "=r" (temp)					\
+	:							\
+	: "memory");						\
+	})
+
+#define adeos_hw_local_irq_restore(x) \
+	__asm__ __volatile__(					\
+	"msr	cpsr_c, %0		@ restore_flags\n"	\
+	:							\
+	: "r" (x)						\
+	: "memory")
+
+#define adeos_hw_local_irq_flags(x) \
+	__asm__ __volatile__(					\
+	"mrs	%0, cpsr		@ save_flags\n"		\
+	  : "=r" (x)						\
+	  :							\
+	  : "memory")
+
+#else /* !CONFIG_ADEOS_CORE */
+
+/* ------------------------------- Linux ------------------------------ */
+
+
 /*
  * Save the current interrupt enable state & disable IRQs
  */
@@ -151,6 +259,9 @@ extern unsigned long cr_alignment;	/* de
 	: "r" (x)						\
 	: "memory")
 
+#endif /* CONFIG_ADEOS_CORE */
+/* ========================================================================= */
+
 #if defined(CONFIG_CPU_SA1100) || defined(CONFIG_CPU_SA110)
 /*
  * On the StrongARM, "swp" is terminally broken since it bypasses the
@@ -165,8 +276,22 @@ extern unsigned long cr_alignment;	/* de
  * dependent on the processor type.
  */
 #define swp_is_buggy
+#else
+#undef swp_is_buggy
 #endif
 
+#ifdef CONFIG_ADEOS_CORE
+
+#define _xchg_save_flags_cli(flags)	adeos_hw_local_irq_save(flags)
+#define _xchg_restore_flags(flags)	adeos_hw_local_irq_restore(flags)
+
+#else /* !CONFIG_ADEOS_CORE */
+
+#define _xchg_save_flags_cli(flags)	local_irq_save(flags)
+#define _xchg_restore_flags(flags)	local_irq_restore(flags)
+
+#endif /* CONFIG_ADEOS_CORE */
+
 static inline unsigned long __xchg(unsigned long x, volatile void *ptr, int size)
 {
 	extern void __bad_xchg(volatile void *, int);
@@ -178,17 +303,17 @@ static inline unsigned long __xchg(unsig
 	switch (size) {
 #ifdef swp_is_buggy
 		case 1:
-			local_irq_save(flags);
+			_xchg_save_flags_cli(flags);
 			ret = *(volatile unsigned char *)ptr;
 			*(volatile unsigned char *)ptr = x;
-			local_irq_restore(flags);
+			_xchg_restore_flags(flags);
 			break;
 
 		case 4:
-			local_irq_save(flags);
+			_xchg_save_flags_cli(flags);
 			ret = *(volatile unsigned long *)ptr;
 			*(volatile unsigned long *)ptr = x;
-			local_irq_restore(flags);
+			_xchg_restore_flags(flags);
 			break;
 #else
 		case 1:	__asm__ __volatile__ ("swpb %0, %1, [%2]"
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/system.h linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/system.h
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/include/asm-arm/system.h	2004-07-22 13:50:53.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/include/asm-arm/system.h	2005-08-12 15:41:58.000000000 -0600
@@ -54,8 +54,36 @@ extern asmlinkage void __backtrace(void)
 #define set_wmb(var, value) do { var = value; wmb(); } while (0)
 #define nop() __asm__ __volatile__("mov\tr0,r0\t@ nop\n\t");
 
+#ifdef CONFIG_ADEOS_CORE
+
+/* the cli is needed to because of the mm-switch (cache, TLB) and __switch_to() */
+#define prepare_to_switch(prev, next) \
+	do { \
+    		struct { struct task_struct *prev, *next; } arg = { (prev), (next) }; \
+    		__adeos_schedule_head(&arg); \
+	} while(0)
+
+#else /* !CONFIG_ADEOS_CORE */
+
 #define prepare_to_switch()    do { } while(0)
 
+#endif /* CONFIG_ADEOS_CORE */
+
+#ifdef CONFIG_EP93XX_CRUNCH
+#include <asm/arch/crunch.h>
+#define crunch_switch(prev, next)			\
+	do {						\
+		if (prev->flags & PF_USEDFPU) {		\
+			save_crunch(prev);		\
+			crunch_disable();		\
+		}					\
+		prev->flags &= ~PF_USEDFPU;		\
+		mb();					\
+	} while (0)
+#else
+#define crunch_switch(prev, next)	do { } while (0);
+#endif
+
 /*
  * switch_to(prev, next) should switch from task `prev' to `next'
  * `prev' will never be the same as `next'.
@@ -63,12 +91,32 @@ extern asmlinkage void __backtrace(void)
  */
 extern struct task_struct *__switch_to(struct task_struct *prev, struct task_struct *next);
 
+#ifdef CONFIG_ADEOS_CORE
+
+/* make a copy of the original definition */
+#define switch_to_orig(prev, next, last)		\
+	do {			 			\
+		crunch_switch(prev, next);		\
+		last = __switch_to(prev, next);		\
+		mb();					\
+	} while (0)
+
+/* add sti to original code to revert cli from from prepare_to_switch() */
+#define switch_to(prev, next, last)			\
+	do {			 			\
+		switch_to_orig(prev, next, last);	\
+	} while (0)
+
+#else /* !CONFIG_ADEOS_CORE */
+
 #define switch_to(prev,next,last)		\
 	do {			 		\
 		last = __switch_to(prev,next);	\
 		mb();				\
 	} while (0)
 
+#endif /* CONFIG_ADEOS_CORE */
+
 /* For spinlocks etc */
 #define __save_flags_cli(x)	local_irq_save(x)
 #define __save_flags(x)		local_save_flags(x)
@@ -94,12 +142,14 @@ extern struct task_struct *__switch_to(s
 #define clf()			__clf()
 #define stf()			__stf()
 
+#ifndef CONFIG_ADEOS_CORE
 #define irqs_disabled()			\
 ({					\
 	unsigned long flags;		\
 	local_save_flags(flags);	\
 	flags & PSR_I_BIT;		\
 })
+#endif /* !CONFIG_ADEOS_CORE */
 
 #define save_flags(x)		local_save_flags(x)
 #define restore_flags(x)	local_irq_restore(x)
@@ -111,4 +161,8 @@ extern struct task_struct *__switch_to(s
 
 #endif /* __KERNEL__ */
 
+#define HAVE_DISABLE_HLT
+void disable_hlt(void);
+void enable_hlt(void);
+
 #endif
